# ChunkCodecLibAec

## Warning: ChunkCodecLibAec is currently a WIP and its API may drastically change at any time.

This package implements the ChunkCodec interface for the following encoders and decoders
using the libaec C library <https://gitlab.dkrz.de/k202009/libaec>

1. `SzipHDF5Codec`, `SzipHDF5EncodeOptions`, `SzipHDF5DecodeOptions`

## Example

```julia-repl
julia> using ChunkCodecLibAec

julia> data = [0x00, 0x01, 0x02, 0x03];

julia> codec = SzipHDF5Codec(;options_mask=Int32(0), bits_per_pixel=32, pixels_per_block=8, pixels_per_scanline=8)

julia> compressed_data = encode(codec, data);

julia> decompressed_data = decode(codec, compressed_data; max_size=length(data), size_hint=length(data));

julia> data == decompressed_data
true
```

The low level interface is defined in the `ChunkCodecCore` package.

module ChunkCodecLibAec

using libaec_jll: libsz

using ChunkCodecCore:
    Codec,
    EncodeOptions,
    DecodeOptions,
    check_in_range,
    check_contiguous,
    DecodingError,
    MaybeSize,
    NOT_SIZE
import ChunkCodecCore:
    decode_options,
    try_decode!,
    try_encode!,
    encode_bound,
    try_find_decoded_size,
    decoded_size_range

export SzipHDF5Codec,
    SzipHDF5EncodeOptions,
    SzipHDF5DecodeOptions,
    SzipDecodingError

if VERSION >= v"1.11.0-DEV.469"
    eval(Meta.parse("public SZ_LSB_OPTION_MASK, SZ_MSB_OPTION_MASK, SZ_EC_OPTION_MASK, SZ_NN_OPTION_MASK"))
end

# reexport ChunkCodecCore
using ChunkCodecCore: ChunkCodecCore, encode, decode
export ChunkCodecCore, encode, decode

include("libaec.jl")
include("libsz.jl")

const sziphdf5_docs = """
Szip HDF5 format compression using the libaec C library: https://gitlab.dkrz.de/k202009/libaec

This is the format used in HDF5 Filter ID: 4.

The maximum decoded size is about 4 GB.
"""

"""
    struct SzipHDF5Codec <: Codec
    SzipHDF5Codec(;options_mask::Int32, bits_per_pixel::Integer, pixels_per_block::Integer, pixels_per_scanline::Integer)

$(sziphdf5_docs)

A `SzipHDF5Codec` can be used as an encoder or decoder.

Warning: Setting `bits_per_pixel` to anything other than
8, 16, 32, or 64 may lead to undefined output.
See below for more details.

# Fields

## `options_mask::Int32`: A bitwise or of the following constants.
- `SZ_MSB_OPTION_MASK`:
    input pixel data is stored most significant byte first
    i.e. big endian.
    Little endian is default and `SZ_LSB_OPTION_MASK` is ignored by libaec,
    but HDF5 tries to ensure exactly one of `SZ_MSB_OPTION_MASK` and `SZ_LSB_OPTION_MASK`
    is specified.
- `SZ_NN_OPTION_MASK`:
    Set if preprocessor is used.
    No preprocessor is default and `SZ_EC_OPTION_MASK` is ignored by libaec,
    but HDF5 tries to ensure exactly one of `SZ_NN_OPTION_MASK` and `SZ_EC_OPTION_MASK`
    is specified.

## `bits_per_pixel::Int32`

Warning: Setting this to anything other than 8, 16, 32, or 64 puts additional restrictions on the decoded data.

The following rules apply for deducing storage size from sample size
(`bits_per_pixel`):

 **sample size**  | **storage size**
--- | ---
 1 -  8 bits  | 1 byte
 9 - 16 bits  | 2 bytes
17 - 32 bits  | 4 bytes
64      bits  | 8 bytes

If a sample requires less bits than the storage size provides, then
you have to make sure that unused bits are not set. Libaec does not
enforce this for performance reasons and will produce undefined output
if unused bits are set. All input data must be a multiple of the
storage size in bytes.

## `pixels_per_block::Int32`: A number in `2:2:32`

Smaller blocks allow the
compression to adapt more rapidly to changing source
statistics. Larger blocks create less overhead but can be less
efficient if source statistics change across the block.

## `pixels_per_scanline::Int32`: A number in `1:$(SZ_MAX_BLOCKS_PER_SCANLINE)*pixels_per_block`

Sets the reference sample interval in pixels. A large `pixels_per_scanline` will
improve performance and efficiency. It will also increase memory
requirements since internal buffering is based on `pixels_per_scanline` size. A smaller
`pixels_per_scanline` may be desirable in situations where errors could occur in the
transmission of encoded data and the resulting propagation of errors
in decoded data has to be minimized.

Setting `pixels_per_scanline` to a multiple of `pixels_per_block` will avoid extra overhead.
"""
struct SzipHDF5Codec <: Codec
    options_mask::Int32
    bits_per_pixel::Int32
    pixels_per_block::Int32
    pixels_per_scanline::Int32
end
function SzipHDF5Codec(;
        options_mask::Int32,
        bits_per_pixel::Integer,
        pixels_per_block::Integer,
        pixels_per_scanline::Integer,
    )
    if bits_per_pixel ∉ 1:32 && bits_per_pixel != 64
        throw(ArgumentError("bits_per_pixel ∈ [1:32; 64;] must hold. Got\nbits_per_pixel => $(bits_per_pixel)"))
    end
    check_in_range(2:2:SZ_MAX_PIXELS_PER_BLOCK; pixels_per_block)
    check_in_range(1:SZ_MAX_BLOCKS_PER_SCANLINE*pixels_per_block; pixels_per_scanline)
    SzipHDF5Codec(
        options_mask,
        bits_per_pixel,
        pixels_per_block,
        pixels_per_scanline
    )
end

decode_options(x::SzipHDF5Codec) = SzipHDF5DecodeOptions(;codec=x)

include("encode.jl")
include("decode.jl")

end # module ChunkCodecLibAec

using Random: Random
using ChunkCodecLibAec:
    ChunkCodecLibAec,
    SzipHDF5Codec,
    SzipHDF5EncodeOptions,
    SzipHDF5DecodeOptions,
    SzipDecodingError,
    SZ_MSB_OPTION_MASK,
    SZ_NN_OPTION_MASK
using ChunkCodecCore: ChunkCodecCore, decode, encode
using ChunkCodecTests: test_codec, test_encoder_decoder
using Test: @testset, @test_throws, @test
using Aqua: Aqua

Aqua.test_all(ChunkCodecLibAec; persistent_tasks = false)

Random.seed!(1234)

@testset "round tripping" begin
    for options_mask in [Int32(0), SZ_MSB_OPTION_MASK, SZ_NN_OPTION_MASK, SZ_MSB_OPTION_MASK | SZ_NN_OPTION_MASK]
        for bits_per_pixel in [8, 16, 32, 64]
            for pixels_per_block in rand(2:2:32, 3)
                for pixels_per_scanline in rand(1:128*pixels_per_block, 3)
                    c = SzipHDF5Codec(;options_mask, bits_per_pixel, pixels_per_block, pixels_per_scanline)
                    @test ChunkCodecCore.is_lossless(c)
                    test_codec(c, SzipHDF5EncodeOptions(c), SzipHDF5DecodeOptions(c); trials=5)
                end
            end
        end
    end
    # SzipHDF5Codec can be used as an encoder and decoder
    c = SzipHDF5Codec(;options_mask=Int32(0), bits_per_pixel=8, pixels_per_block=8, pixels_per_scanline=16)
    test_encoder_decoder(c, c; trials=20)
end
@testset "non multiples of eight `bits_per_pixel`" begin
    for (T, bits) in [(UInt8, 1:7), (UInt16, 9:15), (UInt32, 17:31)]
        for bits_per_pixel in bits
            for big_endian in (false, true)
                c = SzipHDF5Codec(; options_mask=SZ_MSB_OPTION_MASK*big_endian, bits_per_pixel, pixels_per_block=32, pixels_per_scanline=128)
                @test !ChunkCodecCore.is_lossless(c)
                # Important to not have unused bits set.
                # Libaec does not enforce this for performance reasons 
                # and will produce undefined output if unused bits are set.
                pixels = rand(T(0):T(UInt64(2)^bits_per_pixel - UInt64(1)), 1000)
                if big_endian
                    pixels = hton.(pixels)
                end
                u = reinterpret(UInt8, pixels)
                e = encode(c, u)
                @test u == decode(c, e)
                u = zeros(UInt8, 1000)
                e = encode(c, u)
                @test u == decode(c, e)
            end
        end
    end
end
@testset "errors" begin
    @testset "codec constructor" begin
        @test_throws ArgumentError SzipHDF5Codec(;options_mask=Int32(0), bits_per_pixel=-1, pixels_per_block=32, pixels_per_scanline=128)
        @test_throws ArgumentError SzipHDF5Codec(;options_mask=Int32(0), bits_per_pixel=0, pixels_per_block=32, pixels_per_scanline=128)
        @test_throws ArgumentError SzipHDF5Codec(;options_mask=Int32(0), bits_per_pixel=33, pixels_per_block=32, pixels_per_scanline=128)
        @test_throws ArgumentError SzipHDF5Codec(;options_mask=Int32(0), bits_per_pixel=8, pixels_per_block=-1, pixels_per_scanline=128)
        @test_throws ArgumentError SzipHDF5Codec(;options_mask=Int32(0), bits_per_pixel=8, pixels_per_block=3, pixels_per_scanline=128)
        @test_throws ArgumentError SzipHDF5Codec(;options_mask=Int32(0), bits_per_pixel=8, pixels_per_block=34, pixels_per_scanline=128)
        @test_throws ArgumentError SzipHDF5Codec(;options_mask=Int32(0), bits_per_pixel=8, pixels_per_block=32, pixels_per_scanline=0)
        @test_throws ArgumentError SzipHDF5Codec(;options_mask=Int32(0), bits_per_pixel=8, pixels_per_block=32, pixels_per_scanline=4097)
        @test_throws ArgumentError SzipHDF5Codec(;options_mask=Int32(0), bits_per_pixel=8, pixels_per_block=2, pixels_per_scanline=257)
    end
    @testset "unexpected eof" begin
        c = SzipHDF5Codec(;options_mask=Int32(0), bits_per_pixel=8, pixels_per_block=4, pixels_per_scanline=4)
        u = [0x00, 0x01, 0x02, 0x03]
        e = encode(c, u)
        @test decode(c, e) == u
        for i in 1:length(e)
            @test_throws SzipDecodingError decode(c, e[1:i-1])
        end
    end
    @testset "printing errors" begin
        @test sprint(Base.showerror, SzipDecodingError("foo bar")) == "SzipDecodingError: foo bar"
    end
end

# Allow SzipHDF5Codec to be used as an encoder

function pixel_byte_size(bits_per_pixel::Int32)::Int64
    if bits_per_pixel ≤ 8
        1
    elseif bits_per_pixel ≤ 16
        2
    elseif bits_per_pixel ≤ 32
        4
    else
        8
    end
end

function decoded_size_range(x::SzipHDF5Codec)
    Int64(0):pixel_byte_size(x.bits_per_pixel):Int64(typemax(UInt32))
end

function encode_bound(x::SzipHDF5Codec, src_size::Int64)::Int64
    if src_size < 0
        return Int64(-1)
    elseif src_size > typemax(UInt32)
        return typemax(Int64)
    end
    blocks_per_scanline = Int64(cld(x.pixels_per_scanline, x.pixels_per_block))
    bits_per_pixel = if x.bits_per_pixel == 32 || x.bits_per_pixel == 64
        Int32(8)
    else
        x.bits_per_pixel
    end
    bytes_per_pixel = pixel_byte_size(bits_per_pixel)
    n_pixels = fld(src_size, bytes_per_pixel)
    n_scanlines = cld(n_pixels, Int64(x.pixels_per_scanline))
    n_blocks = blocks_per_scanline * n_scanlines
    # overhead from https://ccsds.org/Pubs/121x0b3.pdf Table 5-1
    block_overhead = if bits_per_pixel ≤ 8
        3
    elseif bits_per_pixel ≤ 16
        4
    elseif bits_per_pixel ≤ 32
        5
    else
        throw(ArgumentError("invalid bits_per_pixel"))
    end
    max_bits_per_block = Int64(x.pixels_per_block) * bits_per_pixel + block_overhead
    max_output_bits = max_bits_per_block * n_blocks
    return cld(max_output_bits, 8) + 4
end

function try_encode!(e::SzipHDF5Codec, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    src_size::Int64 = length(src)
    dst_size::Int64 = length(dst)
    check_in_range(decoded_size_range(e); src_size)
    if dst_size < 4
        return NOT_SIZE
    end
    cconv_src = Base.cconvert(Ptr{UInt8}, src)
    cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
    sz_param = SZ_com_t(e.options_mask, e.bits_per_pixel, e.pixels_per_block, e.pixels_per_scanline)
    ret = GC.@preserve cconv_src cconv_dst begin
        src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
        dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
        # src_size must fit in an UInt32 because it is in decoded_size_range(e)
        src_size32 = UInt32(src_size)
        for i in 0:3
            unsafe_store!(dst_p+i, (src_size32>>>(i*8))%UInt8)
        end
        if iszero(src_size)
            # Handle the special case of empty input.
            return Int64(4)
        end
        dst_size -= 4
        dst_p += 4
        destLen = Ref(Csize_t(dst_size))
        @ccall libsz.SZ_BufftoBuffCompress(
            dst_p::Ptr{UInt8}, # dest
            destLen::Ref{Csize_t}, # destLen
            src_p::Ptr{UInt8}, # source
            src_size::Csize_t, # sourceLen
            sz_param::Ref{SZ_com_t}
        )::Cint
    end
    if ret == SZ_OK
        @assert destLen[] ≤ dst_size
        Int64(destLen[]) + Int64(4)
    elseif ret == SZ_MEM_ERROR
        throw(OutOfMemoryError())
    elseif ret == SZ_OUTBUFF_FULL
        return NOT_SIZE
    elseif ret == SZ_PARAM_ERROR
        throw(ArgumentError("invalid szip parameters"))
    else
        error("unknown szip error code: $(ret)")
    end
end

"""
    struct SzipHDF5EncodeOptions <: EncodeOptions
    SzipHDF5EncodeOptions(; kwargs...)

$(sziphdf5_docs)

# Keyword Arguments

- `codec::SzipHDF5Codec`
"""
struct SzipHDF5EncodeOptions <: EncodeOptions
    codec::SzipHDF5Codec
end
function SzipHDF5EncodeOptions(;
        codec::SzipHDF5Codec,
        kwargs...
    )
    SzipHDF5EncodeOptions(
        codec,
    )
end

function ChunkCodecCore.is_lossless(x::SzipHDF5Codec)
    x.bits_per_pixel ∈ (8, 16, 32, 64)
end
ChunkCodecCore.is_lossless(e::SzipHDF5EncodeOptions) = ChunkCodecCore.is_lossless(e.codec)

decoded_size_range(e::SzipHDF5EncodeOptions) = decoded_size_range(e.codec)

encode_bound(e::SzipHDF5EncodeOptions, src_size::Int64)::Int64 = encode_bound(e.codec, src_size)

function try_encode!(e::SzipHDF5EncodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    try_encode!(e.codec, dst, src)
end

# Constants and c wrapper functions ported to Julia from libaec.h https://github.com/MathisRosenhauer/libaec/blob/v1.1.3/include/libaec.h.in

# Return codes of library functions
const AEC_OK                = Cint(0)
const AEC_CONF_ERROR        = Cint(-1)
const AEC_STREAM_ERROR      = Cint(-2)
const AEC_DATA_ERROR        = Cint(-3)
const AEC_MEM_ERROR         = Cint(-4)
const AEC_RSI_OFFSETS_ERROR = Cint(-5)


# The following is the original license info from libaec.h
#=
/**
 * @file libaec.h
 *
 * @section LICENSE
 * Copyright 2024 Mathis Rosenhauer, Moritz Hanke, Joerg Behrens, Luis Kornblueh
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * @section DESCRIPTION
 *
 * Adaptive Entropy Coding library
 *
 */
=#

"""
    SzipDecodingError(msg)

Error for data that cannot be decoded.
"""
struct SzipDecodingError <: DecodingError
    msg::String
end

function Base.showerror(io::IO, err::SzipDecodingError)
    print(io, "SzipDecodingError: ")
    print(io, err.msg)
    nothing
end

"""
    struct SzipHDF5DecodeOptions <: DecodeOptions
    SzipHDF5DecodeOptions(; kwargs...)

$(sziphdf5_docs)

# Keyword Arguments

- `codec::SzipHDF5Codec`
"""
struct SzipHDF5DecodeOptions <: DecodeOptions
    codec::SzipHDF5Codec
end
function SzipHDF5DecodeOptions(;
        codec::SzipHDF5Codec,
        kwargs...
    )
    SzipHDF5DecodeOptions(codec)
end

function try_find_decoded_size(::SzipHDF5DecodeOptions, src::AbstractVector{UInt8})::Int64
    if length(src) < 4
        throw(SzipDecodingError("unexpected end of input"))
    else
        decoded_size = UInt32(0)
        for i in 0:3
            decoded_size |= UInt32(src[begin+i])<<(i*8)
        end
        Int64(decoded_size)
    end
end

function try_decode!(d::SzipHDF5DecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    decoded_size::Int64 = try_find_decoded_size(d, src)
    src_size::Int64 = length(src)
    dst_size::Int64 = length(dst)
    if decoded_size > dst_size
        return NOT_SIZE
    else
        cconv_src = Base.cconvert(Ptr{UInt8}, src)
        cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
        sz_param = SZ_com_t(d.codec.options_mask, d.codec.bits_per_pixel, d.codec.pixels_per_block, d.codec.pixels_per_scanline)
        ret = GC.@preserve cconv_src cconv_dst begin
            src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src) + 4
            dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
            sourceLen = src_size - 4
            destLen = Ref(Csize_t(decoded_size))
            @ccall libsz.SZ_BufftoBuffDecompress(
                dst_p::Ptr{UInt8}, # dest
                destLen::Ref{Csize_t}, # destLen
                src_p::Ptr{UInt8}, # source
                sourceLen::Csize_t, # sourceLen
                sz_param::Ref{SZ_com_t}
            )::Cint
        end
        if ret == SZ_OK
            if destLen[] != decoded_size
                throw(SzipDecodingError("saved decoded size is not correct"))
            end
            return Int64(decoded_size)
        elseif ret == SZ_MEM_ERROR
            throw(OutOfMemoryError())
        elseif ret == SZ_PARAM_ERROR
            throw(ArgumentError("invalid szip parameters"))
        else
            throw(SzipDecodingError("unknown szip error code: $(ret)"))
        end
    end
end
